<div class="row justify-content-between mb-4">
  <div class="col-lg-3 col-md-3 col-sm-6 col-6">
    <button *ngIf="activedStep !== 1" class="btn btn-basic" (click)="prevStep(activedStep)">Précedent</button>
  </div>
  <div class="col-lg-6 col-md-6 col-sm-6 col-6"><h1 class="text-center">Conception de devis</h1></div>
  <div class="col-lg-3 col-md-3 col-sm-6 col-6 text-right">
    <button *ngIf="activedStep !== 4 && activedStep !== 5" class="btn btn-basic" (click)="nextStep(activedStep)"
            [disabled]="canNext()">Suivant</button>
  </div>
</div>

<div class="row">
  <div class="col-lg-12 col-md-12 col-sm-12 col-12">
    <nav ngbNav #nav="ngbNav" class="nav-tabs justify-content-center border-0" [(activeId)]="activedStep"
         (navChange)="onTabChange($event)">
      <ng-container [ngbNavItem]="1">
        <a ngbNavLink class="p0 border-0 position-relative">
          <span class="d-block bg-dark rounded-circle border border-dark step-index"></span>
          <span class="d-block bg-dark line-stepper line-stepper-right"></span>
        </a>
        <ng-template ngbNavContent>
          <div class="row justify-content-center">
            <div class="col-12" style="height: 50px;"></div>
            <div class="col-lg-8 col-md-8 col-sm-12 col-12">
              <h3 class="text-center">Sélection du client</h3>
              <p class="text-center"><a>Client non existant ? Ajoutez le.</a></p>
              <div class="ng-autocomplete m-auto">
                <ng-autocomplete
                  [isLoading]="customerList.length == 0"
                  [data]="customerList"
                  [searchKeyword]="searchedCustomer"
                  (selected)='selectCustomerEvent($event)'
                  (inputChanged)='onChangeCustomerSearch($event)'
                  placeholder="Sélectionner un client"
                  [itemTemplate]="itemTemplate"
                  [notFoundTemplate]="notFoundTemplate">
                </ng-autocomplete>

                <ng-template #itemTemplate let-item>
                  <a [innerHTML]="item.fullname"></a>
                </ng-template>

                <ng-template #notFoundTemplate let-notFound>
                  <div [innerHTML]="notFound"></div>
                </ng-template>
              </div>
              <div *ngIf="quoteData.customer" class="row justify-content-center">
                <div class="col-12" style="height: 50px;"></div>
                <div class="col-lg-3 col-md-4 col-sm-6 col-12">
                  <p><strong>Prénom</strong></p>
                  <p>{{quoteData.customer.first_name}}</p>
                </div>
                <div class="col-lg-3 col-md-4 col-sm-6 col-12">
                  <p><strong>Nom</strong></p>
                  <p>{{quoteData.customer.last_name}}</p>
                </div>
              </div>
              <div *ngIf="quoteData.customer" class="row justify-content-center">
                <div class="col-lg-3 col-md-4 col-sm-6 col-12">
                  <p><strong>Téléphone</strong></p>
                  <p>{{quoteData.customer.phone}}</p>
                </div>
                <div class="col-lg-3 col-md-4 col-sm-6 col-12">
                  <p><strong>Email</strong></p>
                  <p>{{quoteData.customer.email}}</p>
                </div>
              </div>
              <div *ngIf="quoteData.customer" class="row justify-content-center">
                <div class="col-lg-6 col-md-8 col-sm-12 col-12">
                  <p><strong>Adresse</strong></p>
                  <p>{{quoteData.customer.address}}</p>
                </div>
              </div>
            </div>
          </div>
        </ng-template>
      </ng-container>
      <ng-container [ngbNavItem]="2" [disabled]="canNext()">
        <a ngbNavLink class="p0 border-0 position-relative">
          <span class="d-block bg-dark line-stepper line-stepper-left"></span>
          <span class="d-block rounded-circle border border-dark step-index" [class.bg-dark]="activedStep >= 2"></span>
          <span class="d-block bg-dark line-stepper line-stepper-right"></span>
        </a>
        <ng-template ngbNavContent>
          <div class="row justify-content-center">
            <div class="col-12" style="height: 50px;"></div>
            <div class="col-lg-8 col-md-8 col-sm-12 col-12 text-center">
              <p><label for="projectName">Nom du projet</label></p>
              <input type="text" name="projectName" class="form-control max-600 m-auto" id="projectName" placeholder="ex: Lot 4 - Parcelle St-Genis"
                     #projectNameField (change)="handleFieldChange(projectNameField.value, $event)" [value]="quoteData.projectName ? quoteData.projectName : ''" />
            </div>
            <div class="col-lg-8 col-md-8 col-sm-12 col-12 mt-3 text-center">
              <p><label for="houseRange">Gamme de maison</label></p>
              <select *ngIf="rangeList.length > 0" #houseRangeField name="houseRange" id="houseRange" class="custom-select max-600"
                      (change)="handleRangeChange(houseRangeField.value, $event)" [ngModel]="quoteData.houseRange">
                <option ngValue="">----</option>
                <option *ngFor="let item of rangeList" [value]="item.id">{{item.name}}</option>
              </select>
            </div>
          </div>
        </ng-template>
      </ng-container>
      <ng-container [ngbNavItem]="3" [disabled]="canNext()">
        <a ngbNavLink class="p0 border-0 position-relative">
          <span class="d-block bg-dark line-stepper line-stepper-left"></span>
          <span class="d-block rounded-circle border border-dark step-index" [class.bg-dark]="activedStep >= 3"></span>
          <span class="d-block bg-dark line-stepper line-stepper-right"></span>
        </a>
        <ng-template ngbNavContent>
          <div class="row justify-content-center align-items-end">
            <div class="col-12" style="height: 50px;"></div>
            <div class="col-lg-8 col-md-8 col-sm-12 col-12">
              <div class="row justify-content-center">
                <div class="col-lg-4 col-md-12 col-sm-12 col-12 mb-2">
                  <p><label for="fromModuleName">Nom du module</label></p>
                  <input type="text" name="fromModuleName" class="form-control max-600 m-auto" id="fromModuleName"
                         #fromModuleNameField />
                </div>
                <div class="col-lg-5 col-md-8 col-sm-5 col-12 mb-2">
                  <p><label for="fromModelName">Créer à partir du modèle</label></p>
                  <div id="modelAutoCompleteInput" class="w-100 ng-autocomplete m-auto">
                    <ng-autocomplete #moduleModelField
                      [isLoading]="modelList.length == 0"
                      [data]="modelList"
                      [searchKeyword]="searchedModel"
                      (selected)='selectModelEvent($event)'
                      [itemTemplate]="itemTemplate"
                      [notFoundTemplate]="notFoundTemplate">
                    </ng-autocomplete>

                    <ng-template #itemTemplate let-item>
                      <a [innerHTML]="item.name"></a>
                    </ng-template>

                    <ng-template #notFoundTemplate let-notFound>
                      <div [innerHTML]="notFound"></div>
                    </ng-template>
                  </div>

                </div>
                <div class="col-lg-2 col-md-3 col-sm-4 col-12 mb-2">
                  <p><label for="moduleQuantity">Quantité</label></p>
                  <div class="input-group">
                    <input type="number" name="moduleQuantity" class="form-control max-600 m-auto" id="moduleQuantity"
                         #moduleQuantityField />
                    <div class="input-group-append">
                      <span class="input-group-text" id="inputGroupPrepend">m²</span>
                    </div>
                  </div>
                </div>
                <div class="col-lg-1 col-md-1 col-sm-1 col-12 mb-2 d-flex text-center">
                  <button class="btn btn-basic mt-auto mx-auto" (click)="addModule(fromModuleNameField, moduleQuantityField, moduleModelField);">+</button>
                </div>
              </div>
              <div *ngIf="quoteData.modules" class="row justify-content-center">
                <div class="col-12" style="height: 50px;"></div>
                <div *ngFor="let item of quoteData.modules" class="col-12">
                  <div class="shadow p-3 mb-5 bg-white rounded">
                    <p class="mb-0" style="font-size: 20px;"><strong>{{item.name}} - {{item.quantity}}m²</strong></p>
                    <p>Créé à partir de {{item.model.name}}</p>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </ng-template>
      </ng-container>
      <ng-container [ngbNavItem]="4" [disabled]="canNext()">
        <a ngbNavLink class="p0 border-0 position-relative">
          <span class="d-block bg-dark line-stepper line-stepper-left"></span>
          <span class="d-block rounded-circle border border-dark step-index" [class.bg-dark]="activedStep >= 4"></span>
          <span class="d-block bg-dark line-stepper line-stepper-right"></span>
        </a>
        <ng-template ngbNavContent>
          <form #moduleComponentsForm="ngForm" (ngSubmit)="submitComponentModuleForm(moduleComponentsForm)" novalidate>
            <div class="text-center my-3">
              <button class="btn btn-info" [disabled]="!moduleComponentsForm.form.valid">Récapitulatif</button>
            </div>
            <ngb-accordion *ngIf="quoteData.modules && modelComponentList" #acc="ngbAccordion" activeIds="ngb-panel-0">
              <ngb-panel *ngFor="let item of quoteData.modules; let index = index;">
                <ng-template ngbPanelTitle let-opened="opened">
                  <h5 class="m-0">{{item.name}} - {{item.quantity}}m²</h5>
                </ng-template>
                <ng-template ngbPanelContent>
                  <div class="row">
                    <div class="col-lg-8 col-md-4 col-sm-4 col-12"></div>
                    <div class="col-lg-2 col-md-4 col-sm-4 col-12"><p class="text-center font-weight-bold">Quantité</p></div>
                    <div class="col-lg-2 col-md-4 col-sm-4 col-12"><p class="text-center font-weight-bold">Tarif</p></div>
                    <ng-container *ngFor="let cp of modelComponentList">
                      <div *ngIf="cp.model === item.model.id" class="col-lg-8 col-md-4 col-sm-4 col-12">
                        {{cp.component.name}}
                        <input type="hidden" [ngModel]="cp.component.name" name="moduleComponentName-{{item.model.id}}-{{cp.component.id}}">
                        <input type="hidden" [ngModel]="cp.component.amount" name="moduleComponentAmount-{{item.model.id}}-{{cp.component.id}}">
                        <input type="hidden" [ngModel]="cp.proportion" name="moduleComponentProportion-{{item.model.id}}-{{cp.component.id}}">
                        <input type="hidden" [ngModel]="cp.component.unitOfUse" name="moduleComponentUnit-{{item.model.id}}-{{cp.component.id}}">
                      </div>
                      <div *ngIf="cp.model === item.model.id" class="col-lg-2 col-md-4 col-sm-4 col-12">
                        <div class="input-group">
                          <input *ngIf="cp.component.unitOfUse == 'piece'" type="number" step="1"
                                 name="moduleComponentQuantity-{{item.model.id}}-{{cp.component.id}}"
                                 class="form-control max-600 m-auto"
                                 id="moduleComponentQuantity-{{item.model.id}}-{{cp.component.id}}"
                                 [ngModel]="item.quantity * cp.proportion | number:'1.0-0'" />
                          <input *ngIf="cp.component.unitOfUse != 'piece'" type="number" step=".01"
                                 name="moduleComponentQuantity-{{item.model.id}}-{{cp.component.id}}"
                                 class="form-control max-600 m-auto"
                                 id="moduleComponentQuantity-{{item.model.id}}-{{cp.component.id}}"
                                 [ngModel]="item.quantity * cp.proportion | number:'1.2-2'" />
                          <div class="input-group-append">
                            <span class="input-group-text">{{cp.component.unitOfUse}}</span>
                          </div>
                        </div>
                      </div>
                      <div *ngIf="cp.model === item.model.id" class="col-lg-2 col-md-4 col-sm-4 col-12">
                        <span class="d-block" style="width: max-content;margin: auto;padding: 7px 15px;background-color: #f4f4f4;border: 1px solid #ddd;">
                          {{cp.component.amount}} € / {{cp.component.unitOfUse}}
                        </span>
                      </div>
                    </ng-container>
                  </div>
                </ng-template>
              </ngb-panel>
            </ngb-accordion>
          </form>
        </ng-template>
      </ng-container>
      <ng-container [ngbNavItem]="5" [disabled]="canNext()">
        <a ngbNavLink class="p0 border-0 position-relative">
          <span class="d-block bg-dark line-stepper line-stepper-left"></span>
          <span class="d-block rounded-circle border border-dark step-index" [class.bg-dark]="activedStep >= 5"></span>
        </a>
        <ng-template ngbNavContent>
          <div class="row justify-content-center">
            <div class="col-12" style="height: 50px;"></div>
            <div class="col-lg-8 col-md-12 col-sm-12 col-12">
              <h3 class="text-center">Récapitulatif</h3>
              <div class="mt-3 mb-3">
                <table class="table bg-white">
                  <thead>
                  <tr>
                    <th>Module</th>
                    <th>Quantité</th>
                    <th>Montant</th>
                  </tr>
                  </thead>
                  <tbody>
                    <ng-container *ngFor="let module of quoteData.modules">
                      <tr>
                        <td class="font-weight-bold" colspan="3">{{module.name}}</td>
                      </tr>
                      <tr *ngFor="let cp of module.moduleComponents; let isFirst = first; let isLast = last;" class="sub-item-table">
                        <td class="bg-light pl-4" [class.border-0]="!isFirst || !isLast">{{cp.component_name}}</td>
                        <td class="bg-light" [class.border-0]="!isFirst || !isLast">{{cp.quantity}} {{cp.unit_of_use}}</td>
                        <td class="bg-light" [class.border-0]="!isFirst || !isLast">{{cp.quantity * cp.component_amount | number:'1.2-2'}} €</td>
                      </tr>
                    </ng-container>
                  </tbody>
                  <tfoot>
                  <tr>
                    <td></td>
                    <th>Total H.T</th>
                    <th>{{quoteData.total_ht | number:'1.2-2'}} €</th>
                  </tr>
                  <tr>
                    <td></td>
                    <th>Total T.T.C</th>
                    <th>{{quoteData.total_ttc | number:'1.2-2'}} €</th>
                  </tr>
                  </tfoot>
                </table>
              </div>
              <p class="text-center"><button class="btn btn-info" (click)="submitQuote()">Valider</button></p>
            </div>
          </div>
        </ng-template>
      </ng-container>
    </nav>

    <div [ngbNavOutlet]="nav" class="mt-2"></div>
  </div>
</div>
